BasicBrowser/BasicBrowser/urls.py
from django.conf.urls import include
from django.contrib import admin
from django.conf import settings
from django.contrib.auth import views as auth_views
from scoping import views
import BasicBrowser.views as site_views
from django.urls import include, path
from django.views.defaults import page_not_found
from django.conf import settings
from django.urls import re_path
import scoping

# handler404 = scoping.views.handler404


if settings.MAINTENANCE:
    urlpatterns = [
        re_path(r'^', scoping.views.handler404, name="maintenance"),
    ]
else:
    urlpatterns = [
        path('nacsos-legacy/', include([
            # path('lotto/', include('lotto.urls')),
            path('admin/doc/', include('django.contrib.admindocs.urls')),
            # re_path(r'^', scoping.views.handler404, name="maintenance"),
            # path('404', page_not_found, {'exception': Exception()}),
            re_path(r'^tmv_app/', include('tmv_app.urls')),
            re_path(r'^scoping/', include('scoping.urls')),
            re_path(r'^parliament/', include('parliament.urls')),
            path('twitter/', include('twitter.urls')),
            path('lotto', include('lotto.urls')),
            path('signup', site_views.signup, name='signup'),
            re_path(r'^admin/', admin.site.urls),
            re_path(r'^$', site_views.index),
            # path('accounts/', include('django.contrib.auth.urls')),
            path('accounts/password_reset', auth_views.PasswordResetView.as_view(success_url="/"),
                 name="password_reset"),
            path('accounts/password_change', auth_views.PasswordChangeView.as_view(success_url="/scoping"),
                 name="password_change"),
            path('accounts/login/', auth_views.LoginView.as_view(success_url="/"),
                 {'template_name': 'scoping/login.html'}),
            re_path(r'^accounts/logout/$', views.logout_view, name='logout_view'),
        ]))
    ]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ]

BasicBrowser/parliament/urls.py
from django.contrib.auth.decorators import login_required
from parliament import views
from django.urls import re_path
app_name = 'parliament'

urlpatterns = [

    # Homepage, Parliaments
    re_path(r'^$', views.index, name='index'),

    #Parliament pages
    re_path(r'^parliament/(?P<pid>[0-9]+)/$', views.parliament, name='parliament'),
    re_path(r'^parties/(?P<pid>[0-9]+)/$', views.parties, name='parties'),
    re_path(r'^persons/(?P<pid>[0-9]+)/$', views.persons, name='persons'),

    re_path(r'^session/(?P<pid>[0-9]+)/$', views.parlperiod, name='parlperiod'),

    re_path(r'^search/$', views.search, name='search'),
    re_path(r'^search-home/(?P<sid>[0-9]+)/$', views.search_home, name='search-home'),
    re_path(r'^search-list-results/(?P<sid>[0-9]+)/$', views.search_list_results, name='search-list-results'),

    re_path(r'^model-home/(?P<model_id>[0-9]+)/$', views.model_home, name='model-home'),

    re_path(r'^parl-topic/(?P<tid>[0-9]+)/$', views.parl_topic, name='parl-topic'),
    re_path(r'^parl-topic/(?P<tid>[0-9]+)/(?P<pid>[0-9]+)$', views.parl_topic, name='parl-topic-party'),

    re_path(r'^person/(?P<tid>[0-9]+)/$', views.person, name='person'),
    re_path(r'^party/(?P<tid>[0-9]+)/$', views.party, name='party'),

    re_path(r'^document/(?P<did>[0-9]+)/$', views.document, name='document'),
    re_path(r'^utterance/(?P<ut_id>[0-9]+)/$', views.utterance, name='utterance'),
    re_path(r'^paragraph/(?P<par_id>[0-9]+)/$', views.paragraph, name='paragraph'),

]

BasicBrowser/scoping/urls.py
from django.contrib.auth.decorators import login_required
from scoping import views
from django.urls import path, re_path

app_name = 'scoping'

urlpatterns = [


    # Homepage, projet management

    re_path(r'^$', views.index, name='index'),
    re_path(r'^project/(?P<pid>[0-9]+)/$', views.project, name='project'),



    # Query management


    #### Index pages / query set-up (user input)


    re_path(r'^queries/(?P<pid>[0-9]+)/$', views.queries, name='queries'),
    re_path(r'^query_table/(?P<pid>[0-9]+)/$', views.query_table, name='query_table'),

    path('generate_query/<int:pid>/<int:t>', views.generate_query,name="generate_query"),


    re_path(r'^docs/(?P<pid>[0-9]+)/(?P<qid>[0-9]+)$', views.doclist, name='doclist'),

    re_path(r'^create_query/(?P<pid>[0-9]+)$', views.create_query, name='create_query'),

    path('project/<int:pid>/query/add/', login_required(views.QueryCreate.as_view()),name="query_create"),
    path('duplicates/<int:pid>', views.manage_duplicates, name="manage_duplicates"),


    path('find_duplicates/<int:pid>', views.find_duplicates, name="find_duplicates"),
    path('doc_info/<int:did>/<int:did2>', views.doc_info, name="doc_info"),
    path('doc_merge/<int:pid>/<int:d1>/<int:d2>', views.doc_merge, name="doc_merge"),

    ### Paragraph stuff
    path('paragraphs/<int:qid>', views.par_manager, name="par_manager"),

    path('screen_par/<int:tid>/<int:ctype>/<int:doid>/<int:todo>/<int:done>/<int:last_doid>', views.screen_par, name="screen_par"),
    path('add_statement', views.add_statement, name="add_statement"),
    path('del_statement', views.del_statement, name="del_statement"),
    path('rate_par/<int:tid>/<int:ctype>/<int:doid>/<int:todo>/<int:done>', views.rate_par, name="rate_par"),

    ### twitter
    path('twitter-home/<int:pid>', views.twitter_home, name="twitter_home"),
    path('twitter-home/download_screened_tweets/<int:pid>', views.download_screened_tweets, name="download_screened_tweets"),


    ### Meta-analysis stuff
    path('meta-setup/<int:pid>', views.meta_setup, name="meta_setup"),
    path('meta-setup/assign_meta', views.assign_meta, name="assign_meta"),
    path('meta-setup/download_effects/<int:pid>', views.download_effects, name="download_effects"),
    path('meta-setup/report/<int:pid>', views.meta_report, name="meta_report"),
    path('code-document/<int:docmetaid>',views.code_document,name='code_document'),
    path('code-document/<int:docmetaid>/<int:reorder>',views.code_document,name='code_document'),
    path('exclude-document/<int:dmc>',views.ExcludeView.as_view(), name="exclude"),
    path('save-document-code/<int:docmetaid>/<int:dest>',views.save_document_code,name='save_document_code'),
    path('add-effect/<int:docmetaid>',views.add_effect,name='add_effect'),
    path('add-effect/<int:docmetaid>/<int:eff_copy>',views.add_effect,name='add_effect'),
    path('add-effect/<int:docmetaid>/<int:eff_copy>/<int:eff_edit>',views.add_effect,name='add_effect'),
    path('add-intervention/<int:effectid>',views.add_intervention,name='add_intervention'),
    path('add-intervention/<int:effectid>/<int:iid>',views.add_intervention,name='add_intervention'),
    path('add-intervention/<int:effectid>/<int:iid>/<int:i_edit>',views.add_intervention,name='add_intervention'),
    path('download-calculations/<int:id>', views.download_calculations, name="download_calculations"),


    path('db1-db2-report/<int:tagid>', views.db1_db2_report, name="db1_db2_report"),
    path('tag-comparison/<int:tagid>', views.tag_comparison, name="tag_comparison"),

    path('risk-of-bias/<int:dmcid>', login_required(views.RoBCreate.as_view()),name="rob_create"),
    path('edit-risk-of-bias/<int:dmcid>', login_required(views.RoBEdit.as_view()),name="rob_edit"),

    re_path(r'^snowball$', views.snowball, name='snowball'),
    #### Query processing
    re_path(r'^start_snowballing$', views.start_snowballing, name='start_snowballing'),
    re_path(r'^do_snowballing/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)$', views.do_snowballing, name='do_snowballing'),
    re_path(r'^dodocadd/(?P<qid>[0-9]+)$', views.dodocadd, name='dodocadd'),
    re_path(r'^querying/(?P<qid>[0-9]+)/(?P<substep>[0-9]+)/(?P<docadded>[0-9]+)/(?P<q2id>[0-9]+)$', views.querying, name='querying'),
    re_path(r'^querying/(?P<qid>[0-9]+)/(?P<substep>[0-9]+)/(?P<docadded>[0-9]+)/$', views.querying, name='querying'),
    re_path(r'^querying/(?P<qid>[0-9]+)/$', views.querying, name='querying'),
    re_path(r'^snowball_progress/(?P<sbs>[0-9]+)/$', views.snowball_progress, name='snowball_progress'),

    #### Manage Query
    re_path(r'^query/(?P<qid>[0-9]+)/$', views.query, name='query'),
    path('query_dev/<int:qid>/', views.query_dev, name='query_dev'),
    re_path(r'^query-tm-manager/(?P<qid>[0-9]+)/$', views.query_tm_manager, name='query_tm_manager'),
    re_path(r'^query-tm/(?P<qid>[0-9]+)/$', views.query_tm, name='query_tm'),
    re_path(r'^run_model-tm/(?P<run_id>[0-9]+)/$', views.run_model, name='run_model'),

    ### Topic model checking
    path('word_intrusion/<int:run_id>', views.word_intrusion, name="word_intrusion"),
    path('proc_word_intrusion/<int:wid>/<int:tid>', views.proc_word_intrusion, name="proc_word_intrusion"),

    path('topic_intrusion/<int:run_id>', views.topic_intrusion, name="topic_intrusion"),
    path('proc_topic_intrusion/<int:tid>/<int:top_id>', views.proc_topic_intrusion, name="proc_topic_intrusion"),

    #### Manage SBS
    re_path(r'^sbs_allocateDocsToUser/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)$', views.sbs_allocateDocsToUser, name='sbs_allocateDocsToUser'),
    re_path(r'^sbs_setAllQDocsToIrrelevant/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<sbsid>[0-9]+)$', views.sbs_setAllQDocsToIrrelevant, name='sbs_setAllQDocsToIrrelevant'),
    re_path(r'^sbsKeepDoc/(?P<qid>[0-9]+)/(?P<did>.+)$', views.sbsKeepDoc, name='sbsKeepDoc'),
    re_path(r'^sbsExcludeDoc/(?P<qid>[0-9]+)/(?P<did>.+)$', views.sbsExcludeDoc, name='sbsExcludeDoc'),
    re_path(r'^delete_query/(?P<qid>[0-9]+)$', views.delete_query, name='delete'),
    re_path(r'^delete_sbs/(?P<sbsid>[0-9]+)$', views.delete_sbs, name='delete'),

    #### Others
    ## Cities
    re_path(r'^cities/(?P<qid>[0-9]+)$',views.cities, name='cities'),
    re_path(r'^city_data/(?P<qid>[0-9]+)$',views.city_data, name='city_data'),
    re_path(r'^city_docs/(?P<qid>[0-9]+)$',views.city_docs, name='city_docs'),

    re_path(r'^switchmode$', views.switch_mode, name='switch_mode'),

    re_path(r'^categories/(?P<pid>[0-9]+)',views.categories, name='categories'),
    path('filter_categories/<int:pid>/<int:level>', views.filter_categories, name="filter_categories"),
    re_path(r'^category/(?P<tid>[0-9]+)$',views.category, name='category'),
    re_path(r'^download_tdocs/(?P<tid>[0-9]+)$',views.download_tdocs, name='download_tdocs'),
    re_path(r'^authorlist/(?P<tid>[0-9]+)$',views.prepare_authorlist, name='authorlist'),
    re_path(r'^sendauthorlist/(?P<tid>[0-9]+)$',views.send_authorlist, name='send_authorlist'),

    re_path(r'^textplace-autocomplete/$',views.TextPlaceAutocomplete.as_view(create_field='name'),name="textplace-autocomplete"),
    path(r'textfree-autocomplete/',views.TextFreeAutocomplete.as_view(create_field='name'),name="textfree-autocomplete"),
    re_path(r'^country-autocomplete/$',views.CountryAutocomplete.as_view(create_field='name'),name="country-autocomplete"),

    path('duc_country', views.duc_country, name='duc_country'),
    path('duc_place', views.duc_place, name='duc_place'),
    path('duc_text', views.duc_text, name='duc_text'),
    path('duc_year', views.duc_year, name='duc_year'),
    path('duc_number', views.duc_number, name='duc_number'),

    re_path(r'^add_othercat',views.add_othercat, name='add_othercat'),
    re_path(r'^del_othercat',views.del_othercat, name='del_othercat'),

    re_path(r'^add_tech',views.add_tech, name='add_tech'),
    re_path(r'^async_add_tech',views.async_add_tech, name='async_add_tech'),
    path('update_tech/<int:tid>',views.update_tech, name='update_tech'),

    re_path(r'^user/(?P<pid>[0-9]+)$', views.userpage, name='userpage'),

    re_path(r'^update_criteria$', views.update_criteria, name='update_criteria'),

    re_path(r'^docs/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<sbsid>[0-9]+)$', views.doclist, name='doclistsbs'),

    re_path(r'^docssbs/(?P<sbsid>[0-9]+)$', views.doclistsbs, name='doclistsbs'),
    re_path(r'^docrellist/(?P<sbsid>[0-9]+)/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<q3id>[0-9]+)$', views.docrellist, name='docrellist'),
    re_path(r'^sort_docs$', views.sortdocs, name='sortdocs'),
    path('export-docs/<int:qid>/',views.export_ris_docs,name='export-docs'),

    re_path(r'^cycle_score$', views.cycle_score, name='cycle_score'),
    re_path(r'^activate_user$', views.activate_user, name='activate_user'),
    re_path(r'^assign_docs$', views.assign_docs, name='assign_docs'),
    re_path(r'^remove_assignments$', views.remove_assignments, name='remove_assignments'),


    #### Individual docs
    re_path(r'^screen/(?P<tid>[0-9]+)/(?P<ctype>[0-9]+)/(?P<d>[-0-9]+)$', views.screen, name='screen'),
    re_path(r'^do_review$', views.do_review, name='do_review'),
    re_path(r'^add_note', views.add_note, name='add_note'),

    path('screen_doc/<int:doid>', views.screen_doc_id, name='screen_doc_id'),
    path('screen_doc/<int:tid>/<int:ctype>/<int:pos>/<int:todo>', views.screen_doc, name='screen_doc'),
    path('screen_doc/<int:tid>/<int:ctype>/<int:pos>/<int:todo>/<int:js>', views.screen_doc, name='screen_doc'),

    path('rate_doc/<int:tid>/<int:ctype>/<int:doid>/<int:pos>/<int:todo>/<int:rel>', views.rate_doc, name='rate_doc'),
    path('cat_doc/', views.cat_doc, name='cat_doc'),

    # Nice function for updateing many things
    re_path(r'^update_thing',views.update_thing, name='update_thing'),


    re_path(r'^download/(?P<qid>[0-9]+)', views.download, name='download'),
    re_path(r'^download_pdf/(?P<id>[0-9]+)', views.download_pdf, name='download_pdf'),

BasicBrowser/scoping/templates/scoping/snippets/doc_info.html
<div id="docbox">

  {% if merge %}
    <button class="mergebutton" data-keep="{{merge.keep}}" data-throw="{{merge.throw}}">Merge and keep this copy</button>
  {% endif %}
<h4> {{ doc.title | safe }}</h4>

<p style="text-align:left">
{{ doc.content | safe }}
</div>

<p>{{ doc.wosarticle__so | safe}}
    {% if doc.wosarticle__py %}
        ({{ doc.wosarticle__py }})
    {% endif %}
    {% if doc.wosarticle__bp %}
        {{ doc.wosarticle__bp }} - {{ doc.wosarticle__ep }}
    {% endif %}
    {% if doc.wosarticle__di %}
    <a target="_blank" href="http://dx.doi.org/{{ doc.wosarticle__di | safe }}">{{ doc.wosarticle__di | safe}}</a>
    {% endif %}
    {% if doc.wosarticle__dt %}
    Document type: {{doc.wosarticle__dt}}
    {% endif %}
<p style="text-align:left">
{% for au in doc.authors %}
<span>{% if au.AF %}
    {{au.AF | safe}}
    {% else %}
    {{au.AU | safe }}
    {% endif %}
    [{{au.institution | safe}}];</span>
{% endfor %}
{% if doc.wosarticle__de %}
<p style="text-align:left">
    Author keywords: {{doc.wosarticle__de | safe}}
{% endif %}
{% if doc.wosarticle__kwp %}
<p style="text-align:left">
    WoS Keywords Plus: {{doc.wosarticle__kwp | safe}}
{% endif %}


{% if doc.id %}
    {% if project.id %}
      <p style="text-align:left">Document id: <a href="{% url 'scoping:document' project.id doc.id %}">{{doc.id}}</a>
      <p/>
    {% endif %}
{% endif %}

    
{% if doc.docfile %}
    <p style="text-align:left">
        PDF: <a href="{% url 'scoping:download_pdf' doc.docfile.id %}">View</a>
    </p>
{% endif %}

    

BasicBrowser/scoping/templates/scoping/snippets/doc_table.html
{% load scoping_extras %}
<tr class="title">
    {% for f in fields %}
    <td class="field" name="{{f.path}}">{{f.name}}<span class="uparrow sort">&uarr;</span><span class="downarrow sort">&darr;</span></td>
    {% endfor %}
</tr>
{% for doc in docs %}
<tr class="datarow">
    {% for f in fields %}
    <td class="data">{{doc|keyvalue:f.path}}</td>
    {% endfor %}
</tr>
{% endfor %}

BasicBrowser/scoping/templates/scoping/snippets/form_table.html
<table>
{% for field in form %}
    {% if field.name in fields %}
    <tr>
        <th>
        {{ field.errors }}
        {{ field.label_tag }}
        <td>
        {{ field }}
        {% if field.help_text %}
        <br>
        <span class="helptext">{{ field.help_text|safe }}</span>
        {% endif %}
    </tr>
    {% endif %}
{% endfor %}
</table>

BasicBrowser/scoping/templates/scoping/snippets/meta_fields.html
{% load bootstrap4 %}

<table class="table">
    <tr>
        <th>Field Name</th>
        <th>Choices</th>
        <th>Add new choice</th>
    </tr>
    {% for sf in fields %}
        <tr>
            <td>{{sf.name}}</td>
            <td class="extra-high">
                {% if sf.choices == None %}
                    {{sf.type}}
                {% else %}
                    {% for c in sf.choices %}
                        <a href="{% url 'scoping:delete' 'ProjectChoice' c.id %}"><span class="border rounded bg-white p-2">{{c.name}}</span></a>
                    {% endfor %}
                {% endif %}
            </td>
            <td>
                {% if sf.form %}
                <form method="POST" class="form-inline">{% csrf_token %}
                    {% bootstrap_form  sf.form layout='inline' %}
                    {% bootstrap_button 'Save' %}
                </form>
                {% endif %}
            </td>
    {% endfor %}
</table>

BasicBrowser/scoping/templates/scoping/snippets/query_table.html
<tr class="title">
<td>ID</td>
<td>Created by</td>
<td>Title</td>
<td>Text</td>
<td>Date</td>
<td>Documents</td>
<td>Category</td>
<!-- {% if extended %}
<td>Innovation</td>
{% endif %} -->
<td>Delete</td>
</tr>
  {% for query in queries %}
        <tr data-name="{{query.creator}}"  data-tech="{{query.tech}}">
          <td><a href="{% url 'scoping:query' query.id %}">{{ query.id }}</a></td>
          <td>{{ query.creator }}</td>
          <td>{{ query.title }}</td>
          <td class="ltext">{{ query.text }}</td>
          <td>{{ query.date }}</td>
          {% if query.r_count is not None %}
            <td><a href="{% url 'scoping:doclist' project.id query.id %}">{{ query.r_count }}</a></td>
          {% else %}
            <td><a href="{% url 'scoping:querying' query.id %}">View progress</a></td>
          {% endif %}
          <td>
            <select class="qtag" data-thing="Category" data-query="{{query.id}}" autocomplete="off">
              {% if not query.category %}
              <option selected value="None">{{query.category}}</option>
              {% else %}
              <option value="None">None</option>
              {% endif %}
              {% for t in techs %}
                  {% if t == query.category %}
                  <option selected value={{t.id}}>{{t.name}}</option>
                  {% else %}
                  <option value={{t.id}}>{{t.name}}</option>
                  {% endif %}
              {% endfor %}
          </select>
      </td>
      <!-- {% if extended %}
      <td>
        <select class="qtag" data-thing="Innovation" data-query="{{query.id}}" autocomplete="off">
          {% if not query.innovation %}
          <option selected value="None">{{query.innovation}}</option>
          {% else %}
          <option value="None">None</option>
          {% endif %}
          {% for i in innovations %}
              {% if i == query.innovation %}
              <option selected value={{i.id}}>{{i.name}}</option>
              {% else %}
              <option value={{i.id}}>{{i.name}}</option>
              {% endif %}
          {% endfor %}
      </select>
  </td>
      {% endif %} -->
      <td><a href="{% url 'scoping:delete' 'Query' query.id %}">
          <button class="btn" onclick="return confirm('Are you sure you would like to delete this query?');">Delete</button>
      </a></td>
  </tr>

{% endfor %}

BasicBrowser/scoping/templates/scoping/snippets/screen_doc_nocols.html
    <div class="col-9">

            <div class="row">
                  <div class="col-12">
                      <div class="border rounded bg-white p-3 m-2 position-sticky sticky-top">
                          <div><h4>Query criteria</h4></div>
                          {% if "table" in criteria %}
                            <div class="padded">
                          {% else %}
                            <div>
                          {% endif %}
                          {{criteria |safe }}
                          </div>
                      </div>
                  </div>
              </div>

              <div class="row">
                  <div class="col-12">
                      <div class="border rounded bg-white p-3 m-2 position-sticky sticky-top">
                    {% if do.utterance_linked %}
                        <link href="https://afeld.github.io/emoji-css/emoji.css" rel="stylesheet">
                        <div id="docbox">
                            Speech <a href="{% url 'parliament:utterance' doc.id %}"> {{doc.id}} </a>
                            from <a href="{% url 'parliament:document' doc.document.id %}"> {{doc.document}} </a>
                            with {{doc.paragraph_set.count}} paragraphs
                        {% include "parliament/snippets/ut_info.html" with ut=doc %}
                        </div>
                    {% elif do.tweet %}
                        <div id="docbox">
                        {% include "scoping/snippets/tweet_info.html" with tweet=do.tweet %}
                        </div>
                    {% else %}
                        {% include "scoping/snippets/doc_info.html" with query=dmc.query %}
                    {% endif %}
                      </div>
                </div>


              </div>
              <div class="row">
                <div class="col-12">
                {% for n,l in levels %}

                  {% if project.rating_first %}

                    <div class="border rounded bg-white my-2 p-2 small hidden catbox " data-level={{forloop.counter}}>
                  {% else %}
                    <div class="border rounded bg-white my-2 p-2 small" data-level={{forloop.counter}}>
                  {% endif %}
                      {% if "<wholetext>" in n %}
                        {{n |safe}}
                      {% else %}
                        Which {{n}} categories is this document relevant to?
                      {% endif %}

                        (hover for more info)
                                <hr>
                            {% for t in l %}
                            <button value="{{t.1.id}}" type="button" class="btn cat {{t.0}}" data-unique="{{t.1.parent_category.unique_children}}" data-level={{forloop.parentloop.counter}} data-nofurther="{{t.1.no_further}}" data-toggle="tooltip" data-placement="top" title="{{t.1.description}}">{{t.1}}</button>

                            {% endfor %}
                    </div>

                {% endfor %}
                </div>
              </div>

              <div id="finishbutton" class="border rounded bg-white my-3 p-2 hidden">
               {% csrf_token %}
              <p> Finished screening?
                <hr>
                <a id="r-3" href="{% url 'scoping:rate_doc' tag.id ctype do.id pos todo 3 %}" class="btn btn-secondary m-1 b-maybe {% if do.relevant == 3 %} True {% endif %}">Done</a>
              </div>
      </div>
      <div class="col-3">

                <div class="border rounded bg-white my-3 p-2">
                    Add a note to this document
                    <hr>
                    <form action="{% url 'scoping:add_note' %}" method="post">
                      {% csrf_token %}
                      <input type="hidden" name="next" value="{{ request.path }}">
                      {% if do.utterance_linked %}
                        <input type="hidden" name="ut_id" value="{{do.utterance.id}}"></input>
                      {% elif do.tweet %}
                        <input type="hidden" name="status_id" value="{{do.tweet.id}}"></input>
                      {% else %}
                        <input type="hidden" name="docn" value="{{do.doc.id}}"></input>
                      {% endif %}

                      <input type="hidden" name="tag" value="{{tag.id}}"></input>
                    <textarea id="notebox" class="form-control" name="note" rows=3></textarea>
                    <br>
                    <p>
                    <button type="submit" class="btn btn-primary">Add note</button>
                    </form>
                </div>
                {% for note in notes %}
                <div class="border rounded bg-white my-3 p-2 note">
                  <p class="notedesc"><b>{{note.date}}, {{note.user.username}} wrote...</b>
                  <hr>
                  {{note.text}}
                  <hr>
                  <a href="{% url 'scoping:delete' thing='Note' thingid=note.pk %}">Delete
                  </a>
                </div>
                {% endfor %}

        </div>

BasicBrowser/scoping/templates/scoping/snippets/tweet_info.html
<h4> {{tweet.author.screen_name}} at {{ tweet.created_at }}</h4>
<!-- <p><a href="https://twitter.com/{{tweet.author.screen_name}}/status/{{tweet.id}}">twitter.com</a> -->
<p>{{tweet.text}}